// Manhattan Requiem (X1) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x400*5*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	if (!fp) return false;
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

int main(int argc, char *argv[])
{

	char fname[FILENAME_MAX];
	int d,i,diskid=0;
	unsigned char id[] = "Manhattan X1 Sys";

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	disk.SetRecordRange(0x01,0x10);

	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x05);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x0100);
		if (!memcmp(&buff[1], id, sizeof(id)-1)) {
			printf("Manhattan Requiem (X1) Disk AF܂.\n");
			fcut("PSGDRV", 0x08, 0x04, 0x00, 0x02, 0x03, 0x0000, 0x0800);
			fcut("OPMDRV", 0x08, 0x04, 0x00, 0x04, 0x03, 0x0000, 0x0800);
			fcut("PSGMUS", 0x07, 0x03, 0x01, 0x01, 0x03, 0x0000, 0x1800);
			fcut("OPMMUS", 0x09, 0x04, 0x01, 0x01, 0x03, 0x0000, 0x2800);
			continue;
		}
	}
	return 0;
}

