// Manhattan Requiem t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <direct.h>

#include "d88.h"

#define MAXFILE (0x9b)

unsigned char dir[0x800];
unsigned char buff[0x400*5*80];

D88 disk;
FILE *fp;

// wordl擾
int GetWord(unsigned char *_p) {
	int ret;
	ret = (_p[1]<<8) + _p[0];
	return ret;
}

bool dfcut(char *_fname, int _disk, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	disk.SelectDisk(_disk);
	disk.SetRecordRange(0x01,0x05);
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
//	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	if (!fp) return false;
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int mode = 1;
	unsigned char id[] = "Manhattan X1 Sys";

	if (argc<2 || argc>3)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file] [-d]\n",argv[0]);
		fprintf(stderr, "       -d : not make FILES directory\n");
		return 1;
	}

	if (argc==3 && !strcmp(argv[2],"-d"))
	{
		mode=0;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();

	disk.SelectDisk(0);
	disk.SetRecordRange(0x01,0x10);
	disk.ReadDATA(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x0100);
	if (!memcmp(&buff[1], id, sizeof(id)-1)) {
		printf("Manhattan Requiem (X1) Disk AF܂.\n");
	}
	else {
		fprintf(stderr, "fBXNFł܂.\n");
		return 1;
	}
	// DIRǂݍ
	disk.ReadDATA(0x00, 0x00, 0x00, 0x05, 0x01, dir, sizeof(dir));

	int drv,trk,sec,ofs,num,size;
	unsigned char* tblptr = &dir[0x0466];

	if (mode) {
		_mkdir("FILES");				// fBNg쐬
		_chdir("FILES");				// fBNgړ
	}

	// fBNgǊOt@C̐؂o
	dfcut("PSGDRV", 0x00, 0x08, 0x04, 0x00, 0x02, 0x03, 0x0000, 0x0800);
	dfcut("OPMDRV", 0x00, 0x08, 0x04, 0x00, 0x04, 0x03, 0x0000, 0x0800);
	dfcut("PSGMUS", 0x00, 0x07, 0x03, 0x01, 0x01, 0x03, 0x0000, 0x1800);
	dfcut("OPMMUS", 0x00, 0x09, 0x04, 0x01, 0x01, 0x03, 0x0000, 0x2800);

	// t@C̐؂o
	for (int f=0; f<=MAXFILE; f++) {
		drv = (tblptr[0] < 0x50)? 0 : 1;
		trk = (tblptr[0] < 0x50)? tblptr[0] : tblptr[0]-0x50;
		sec =  tblptr[1];
		ofs = (tblptr[2]<<8) + tblptr[3];
		num =  tblptr[4];
		size = num*0x400;

		sprintf(fname,"%c%02X",'A'+drv,f);
		printf("%s Drive=%d Track=%02d Sector=%1d Offset=%04x Size=%02x(%06x)",fname,drv+1,trk,sec,ofs,num,size);
		if (drv==1 && numdisk<2) {
			printf(" [SKIP]");
		} else {
			dfcut(fname, drv, trk, trk>>1, trk&1, sec, 0x03, ofs, size);
		}
		printf("\n");
		tblptr += 5;
	}

	if (mode) {
		_chdir("..");				// fBNgړ
	}
	return 0;
}

